#!/usr/bin/env python3

import sys
from ucb import main
from mapreduce import emit

from trends import extract_words, get_word_sentiment, has_sentiment, sentiment_value
from shakespeare import get_character_name

def run():
    current_character = ''
    for line in sys.stdin:
        new_character_name = get_character_name(line)
        if new_character_name:
            current_character = new_character_name

        total = 0
        count = 0
        for word in extract_words(line):
            s = get_word_sentiment(word)
            if has_sentiment(s):
                total += sentiment_value(s)
                count += 1
        if count > 0:
            emit(current_character, total / count)
        else:
            emit(current_character, 0)

if __name__ == '__main__':
    run()
